VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsDebugMaze"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
Option Base 0

' current information of the robot
Dim curX As Integer
Dim curY As Integer
Dim curDirection As Integer

Dim Maze(MaxX - 1, MaxY - 1) As Integer
Dim Direction2X(3) As Integer
Dim Direction2Y(3) As Integer

Public Sub Init()

End Sub

Private Sub Class_Initialize()
  Dim i As Integer
  Dim j As Integer
  
  curX = MaxX / 2
  curY = 0
  curDirection = South
  
  For i = 1 To MaxX - 1
    For j = 1 To MaxY - 1
        Maze(i, j) = Wall
    Next j
  Next i
  
  Maze(curX, curY) = Road
  Maze(curX, curY + 1) = Road
  Maze(curX, curY + 2) = Branch
  Maze(curX, curY + 3) = Road
  Maze(curX, curY + 4) = Road
  Maze(curX + 1, curY + 4) = Road
  Maze(curX + 2, curY + 4) = Road
  Maze(curX + 2, curY + 3) = Road
  Maze(curX + 1, curY + 2) = Road
  Maze(curX + 2, curY + 2) = Road
  Maze(curX - 1, curY + 2) = Road
  Maze(curX - 2, curY + 2) = Branch
  Maze(curX - 2, curY + 1) = Road
  Maze(curX - 2, curY) = Wall
  Maze(curX - 2, curY + 3) = Road
  Maze(curX - 3, curY + 2) = Road
  Maze(curX - 4, curY + 2) = Road
  Maze(curX - 2, curY + 4) = Road
  Maze(curX - 2, curY + 5) = Gold

  Randomize 1232
  makeMaze
  'Maze(MaxX - 2, MaxY - 2) = Gold
  MakeBranch
  curX = 1
  curY = 1
  curDirection = South
  
  Direction2X(North) = 0
  Direction2X(South) = 0
  Direction2X(West) = -1
  Direction2X(East) = 1
  Direction2Y(North) = -1
  Direction2Y(South) = 1
  Direction2Y(West) = 0
  Direction2Y(East) = 0
  
  frmMaze.ctrlStep.Visible = True
  frmMaze.ctrlDbgX.Visible = True
  frmMaze.ctrlDbgY.Visible = True
  frmMaze.ctrlDbgDirection.Visible = True
  frmMaze.ctrlDbgX.Caption = curX
  frmMaze.ctrlDbgY.Caption = curY
  frmMaze.ctrlDbgDirection.Caption = GetDirectionName(curDirection)
End Sub

Private Sub makeMaze()
' Create a random maze.  The strategy is to start with
' a grid of disconnnected "rooms" separated by walls.
' then look at each of the separating walls, in a random
' order.  If tearing down a wall would not create a loop
' in the maze, then tear it down.  Otherwise, leave it in place.
  Dim i As Integer
  Dim j As Integer
  Dim r As Integer
  Dim emptyCt As Integer ' number of rooms
  Dim wallCt As Integer  ' number of walls
  ' position of walls between rooms
  Dim wallrow((MaxX * MaxY) / 2) As Integer
  Dim wallcol((MaxX * MaxY) / 2) As Integer
  emptyCt = 0
  'start with everything being a wall
  For i = 0 To MaxY - 1
    For j = 0 To MaxX - 1
      Maze(j, i) = Wall
    Next j
  Next i
  
  For i = 1 To MaxY - 2 Step 2 ' make a grid of empty rooms
    For j = 1 To MaxX - 2 Step 2
        emptyCt = emptyCt + 1
        Maze(j, i) = -emptyCt ' each room is represented by a different negative number
        If i < MaxY - 2 Then ' record info about wall below this room
            wallrow(wallCt) = i + 1
            wallcol(wallCt) = j
            wallCt = wallCt + 1
        End If
        If j < MaxX - 2 Then ' record info about wall to right of this room
            wallrow(wallCt) = i
            wallcol(wallCt) = j + 1
            wallCt = wallCt + 1
        End If
     Next j
  Next i
  For i = wallCt - 1 To 1 Step -1
        r = Rnd() * i  ' choose a wall randomly and maybe tear it down
        tearDown wallrow(r), wallcol(r)
        wallrow(r) = wallrow(i)
        wallcol(r) = wallcol(i)
  Next i
  For i = 1 To MaxY - 2 ' replace negative values in maze with emptyCode
    For j = 1 To MaxX - 2
      If Maze(j, i) < 0 Then
        Maze(j, i) = Road
      End If
    Next j
  Next i
End Sub

Private Sub tearDown(row As Integer, col As Integer)
' Tear down a wall, unless doing so will form a loop.  Tearing down a wall
' joins two "rooms" into one "room".  (Rooms begin to look like corridors
' as they grow.)  When a wall is torn down, the room codes on one side are
' converted to match those on the other side, so all the cells in a room
' have the same code.   Note that if the room codes on both sides of a
' wall already have the same code, then tearing down that wall would
' create a loop, so the wall is left in place.
  If row Mod 2 = 1 And Maze(col - 1, row) <> Maze(col + 1, row) Then
    ' row is odd; wall separates rooms horizontally
    fill row, col - 1, Maze(col - 1, row), Maze(col + 1, row)
    Maze(col, row) = Maze(col + 1, row)
  ElseIf row Mod 2 = 0 And Maze(col, row - 1) <> Maze(col, row + 1) Then
    ' row is even; wall separates rooms vertically
    fill row - 1, col, Maze(col, row - 1), Maze(col, row + 1)
    Maze(col, row) = Maze(col, row + 1)
  End If
End Sub
    
Private Sub fill(row As Integer, col As Integer, ByVal replace As Integer, ByVal replaceWith As Integer)
  ' called by tearDown() to change "room codes".
  Debug.Assert replace <> replaceWith
  If Maze(col, row) = replace Then
    Maze(col, row) = replaceWith
    fill row + 1, col, replace, replaceWith
    fill row - 1, col, replace, replaceWith
    fill row, col + 1, replace, replaceWith
    fill row, col - 1, replace, replaceWith
  End If
End Sub

Private Sub MakeBranch()
' change the branch node to Branch
  Dim i As Integer
  Dim j As Integer
  For i = 0 To MaxX - 1
    For j = 0 To MaxY - 1
      SetBranch i, j
    Next j
  Next i
End Sub

Private Sub SetBranch(x As Integer, y As Integer)
' return True if this is a branch node
    Dim i As Integer
    Dim n As Integer
    
    If Maze(x, y) <> Road Then
        Exit Sub
    End If
    i = 0
    If (x > 0) Then
      n = Maze(x - 1, y)
      If n = Road Or n = Branch Or n = Gold Then
        i = i + 1
      End If
    End If
    If (x < MaxX - 1) Then
      n = Maze(x + 1, y)
      If n = Road Or n = Branch Or n = Gold Then
        i = i + 1
      End If
    End If
    If (y > 0) Then
      n = Maze(x, y - 1)
      If n = Road Or n = Branch Or n = Gold Then
        i = i + 1
      End If
    End If
    If (y < MaxY - 1) Then
      n = Maze(x, y + 1)
      If n = Road Or n = Branch Or n = Gold Then
        i = i + 1
      End If
    End If
    If i > 2 Then
      Maze(x, y) = Branch
    End If
End Sub

' for clsControl

' Start two motors go forward in speed "Speed"
Sub GoForward(ByVal Speed As Integer)
End Sub

' Start two motors go backward in speed "Speed"
Sub GoBackward(ByVal Speed As Integer)
End Sub

' go through certain distance and stop
' if distance is negative, go backward
Sub MoveAndStop(ByVal distance As Double)
  Debug.Print distance
  If Maze(curX, curY) = Gold Then
    Exit Sub
  End If
  If distance = 0 Then
    Exit Sub
  End If
  If Abs(distance) <> SquareLength - RotationCenter And Abs(distance) <> SquareLength Then
    Exit Sub
  End If
  If distance < 0 Then
    curX = curX - Direction2X(curDirection)
    curY = curY - Direction2Y(curDirection)
  Else
    curX = curX + Direction2X(curDirection)
    curY = curY + Direction2Y(curDirection)
  End If
  frmMaze.ctrlDbgX.Caption = curX
  frmMaze.ctrlDbgY.Caption = curY
  frmMaze.ctrlDbgDirection.Caption = GetDirectionName(curDirection)
End Sub

' Rotate the robot in an angle defined in the parameter
' Let it rotate during the running
Sub Rotate(Angle As Integer)
  MoveAndStop -GetSquareLength
  Select Case Angle
    Case 90
      curDirection = (curDirection + 1) Mod 4
    Case -90
      curDirection = (curDirection + 3) Mod 4
    Case 180
      curDirection = (curDirection + 2) Mod 4
    Case Else
      Debug.Assert False
  End Select
  frmMaze.ctrlDbgDirection.Caption = GetDirectionName(curDirection)
End Sub

Sub StopMotor()

End Sub

' for clsSensor

' Get the current color from the light sensor
Function GetColor() As Integer
  GetColor = Maze(curX, curY)
End Function

' Adjust the direction of the robot, after it crosses a square
Sub Adjust()

End Sub

' return whether the robot reaches a new square
Function ReachNewSquare() As Boolean
  ReachNewSquare = True
  curX = curX + Direction2X(curDirection)
  curY = curY + Direction2Y(curDirection)
  frmMaze.ctrlDbgX.Caption = curX
  frmMaze.ctrlDbgY.Caption = curY
End Function

Function GetSquareLength() As Double
  GetSquareLength = SquareLength
End Function

' return the distance that the robot goes after passing the last square
Function GetDistance() As Double
  Debug.Assert False
End Function

