VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsSearch"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit
Option Base 0

' current information of the robot
Dim curX As Integer
Dim curY As Integer
Dim curDirection As Integer

Dim Maze(MaxX - 1, MaxY - 1) As Integer
Dim Route As clsStack

Dim Direction2X(3) As Integer
Dim Direction2Y(3) As Integer

Dim Finish As Boolean

' Returns the current column of the robot
Public Property Get x() As Integer
    x = curX
End Property

' Returns the current column of the robot
Public Property Get y() As Integer
    y = curY
End Property

' Returns the current direction of the robot
Public Property Get direction() As Integer
    direction = curDirection
End Property

Public Property Get Direct2X(x As Integer) As Integer
    Direct2X = Direction2X(x)
End Property

Public Property Get Direct2Y(x As Integer) As Integer
    Direct2Y = Direction2Y(x)
End Property

Public Property Get GetRoute() As clsStack
    Set GetRoute = Route
End Property

Public Property Get MazeMap(ByVal x As Integer, ByVal y As Integer) As Integer
    If x < 0 Or y < 0 Or x >= MaxX Or y >= MaxY Then
      Debug.Print "Maze index out of bound"
    End If
    MazeMap = Maze(x, y)
End Property

Public Sub Init()
  Dim i As Integer
  Dim j As Integer
  
  FoundGold = False
  Finish = False
  curX = MaxX / 2
  curY = MaxY / 2
  curDirection = South
  
  If DebugSearch Then
    curX = 1
    curY = 1
    curDirection = South
  End If
  
  'for debug
  'Maze(1, 1) = Wall
  'Maze(1, 2) = Road
  'Maze(1, 3) = Branch
  'Maze(1, 4) = Gold
    
  Direction2X(North) = 0
  Direction2X(South) = 0
  Direction2X(West) = -1
  Direction2X(East) = 1
  Direction2Y(North) = -1
  Direction2Y(South) = 1
  Direction2Y(West) = 0
  Direction2Y(East) = 0
  
  Set Route = New clsStack
  Call Route.Push(curX, curY)
  
  For i = 0 To MaxX - 1
    For j = 0 To MaxY - 1
        Maze(i, j) = Unknown
    Next j
  Next i
  
  frmMaze.ctrlCurPos = Format(curX) + "," + Format(curY)
  frmMaze.ctrlCurDirection = GetDirectionName(curDirection)
End Sub

' initialize
Private Sub Class_Initialize()
  Init
End Sub

Public Sub SetCurrentColor(color As Integer)
  If Maze(curX, curY) = Unknown Then
    Maze(curX, curY) = color
  Else
    Debug.Assert Maze(curX, curY) = color
  End If
  If color = Gold Then
    SetWall curX, curY
    curX = x
    curY = y
    frmMaze.PBrickCtrl.PlaySystemSound 3
    'Route.Push x, y
    'dis = Sensor.GetSquareLength - 4
    'Control.MoveAndStop dis
    'Control.Rotate (180)
    'curDirection = (curDirection + 2) Mod 4
    'Control.StopMotor
    'If Not DebugSearch Then
    frmMaze.ctrlTimer1.Enabled = False
    'End If
    Beep
    MsgBox "We found the gold!"
    FoundGold = True
  End If
End Sub

Sub BackTrack(x As Integer, y As Integer, color As Integer)
  Dim Info As Location
  
  ' get the last square on the route
  Call Route.Top(Info.x, Info.y)
  Debug.Assert Info.x = x And Info.y = y ' we are back tracking
  ' the color can only be Road or Branch
  Debug.Assert Maze(x, y) = color And (color = Road Or color = Branch)
    
  curX = x
  curY = y
  If Route.Length = 1 Then
    Finish = True
    frmMaze.ctrlTimer1.Enabled = False
    Exit Sub
  End If
  GoBack curX, curY, curDirection

End Sub

Sub Search(color As Integer)
  Dim x As Integer
  Dim y As Integer
  Dim Info As Location
  Dim NextSquare As Location
  Dim NextDirection As Integer
  Dim b As Boolean
  Dim dis As Integer
  
  If Finish Then
    Exit Sub
  End If
  ' update the Maze
  x = curX + Direction2X(curDirection)
  y = curY + Direction2Y(curDirection)
  If FoundGold Then
    'BackTrack x, y, color
  Else
    ' the robot should be inside the maze
    Debug.Assert x >= 0 And x < MaxX And y >= 0 And y < MaxY
    
    ' get the last square on the route
    Call Route.Top(Info.x, Info.y)
    If Info.x = x And Info.y = y Then ' we are back tracking
      ' the color can only be Road or Branch
      Debug.Assert Maze(x, y) = color And (color = Road Or color = Branch)
      
      curX = x
      curY = y
      If color = Road Or _
         color = Branch And TriedAll(x, y) Then 'if all road besides this branch were tried
        ' continue go back
        GoBack curX, curY, curDirection, RotationCenter
      Else ' try another road of the branch
        Debug.Assert color = Branch And Not TriedAll(x, y)
        b = ProcessBranch(x, y, curDirection, RotationCenter)
        Debug.Assert b
      End If
    Else ' this is a new square
      If Maze(x, y) <> Unknown Then ' this cell has been reached
        Debug.Assert Maze(x, y) = color And color <> Gold
        ' this a cycle in the maze, go back
        '   to the center of the last square
        'Control.StopMotor
        x = curX
        y = curY
        If Not ProcessBranch(curX, curY, curDirection, -(Sensor.GetSquareLength - RotationCenter)) Then
          GoBack curX, curY, curDirection, -(Sensor.GetSquareLength - RotationCenter)
        End If
      Else ' this cell has not been reached
        Maze(x, y) = color
        Select Case color
          Case Wall
            ' back to the center of the last square
            ' maybe need adjust the distance here
            'Control.StopMotor
            If Not ProcessBranch(curX, curY, curDirection, -(Sensor.GetSquareLength - RotationCenter)) Then
              GoBack curX, curY, curDirection, -(Sensor.GetSquareLength - RotationCenter)
            End If
          Case Road    ' record the route, continue going
            SetWall curX, curY
            curX = x
            curY = y
            Route.Push x, y
          Case Branch ' record the route, continue going
            SetWall curX, curY
            curX = x
            curY = y
            Route.Push x, y
          Case Gold
            SetWall curX, curY
            curX = x
            curY = y
            frmMaze.PBrickCtrl.PlaySystemSound 3
            'Route.Push x, y
            'dis = Sensor.GetSquareLength - 4
            'Control.MoveAndStop dis
            'Control.Rotate (180)
            'curDirection = (curDirection + 2) Mod 4
            'Control.StopMotor
            'If Not DebugSearch Then
            frmMaze.ctrlTimer1.Enabled = False
            'End If
            Beep
            MsgBox "We found the gold!"
            FoundGold = True
          Case Else
            Debug.Assert "Unknown color from GetColor!"
        End Select
      End If
    End If
  End If
  
  frmMaze.ctrlCurPos = Format(curX) + "," + Format(curY)
  frmMaze.ctrlCurDirection = GetDirectionName(curDirection)
  ' redraw the frame
  frmMaze.Refresh
  'frmMaze.ctrlMazePic.Refresh
End Sub

' decide where to go at a branch or road
' if there is new square to go, return true
' return false otherwise
Function ProcessBranch(curX As Integer, curY As Integer, ByRef curDirection As Integer, Optional dis As Integer = 0) As Boolean
  Dim NewX As Integer
  Dim NewY As Integer
  Dim newDirection As Integer
  Dim newSquare As Location
  Dim curSquare As Location
  
  NewX = curX + Direction2X(curDirection)
  NewY = curY + Direction2Y(curDirection)
  If Maze(NewX, NewY) = Unknown Then ' do not change direction
    ProcessBranch = True
    Exit Function
  End If
  curSquare.x = curX
  curSquare.y = curY
  newSquare = curSquare
  If curX > 0 And Maze(curX - 1, curY) = Unknown Then
    newSquare.x = curX - 1
  ElseIf curX < MaxX - 1 And Maze(curX + 1, curY) = Unknown Then
    newSquare.x = curX + 1
  ElseIf curY > 0 And Maze(curX, curY - 1) = Unknown Then
    newSquare.y = curY - 1
  ElseIf curY < MaxY - 1 And Maze(curX, curY + 1) = Unknown Then
    newSquare.y = curY + 1
  End If
  
  If newSquare.x = curSquare.x And newSquare.y = curSquare.y Then ' no new square to try
    ProcessBranch = False
  Else
    newDirection = GetDirection(curSquare, newSquare)
    Control.MoveAndStop dis
    Control.Rotate (GetAngle(curDirection, newDirection))
    'Control.GoForward speed
    curDirection = newDirection
    ProcessBranch = True
  End If
End Function

Private Sub GoBack(curX As Integer, curY As Integer, ByRef curDirection As Integer, Optional dis As Integer = 0)
  Dim Info As Location
  Dim NextSquare As Location
  Dim NextDirection As Integer
  
  Route.Pop Info.x, Info.y
  Debug.Assert Info.x = curX And Info.y = curY
  If Route.IsEmpty Then
    Call Route.Push(curX, curY)
  Else
    Route.Top NextSquare.x, NextSquare.y
    NextDirection = GetDirection(Info, NextSquare)
    If NextDirection <> curDirection Then ' we need turn
      Control.MoveAndStop dis
      Control.Rotate (GetAngle(curDirection, NextDirection))
    End If
    curDirection = NextDirection
  End If
End Sub

' return the direction needed if we go from FromSquare to ToSquare
Friend Function GetDirection(FromSquare As Location, ToSquare As Location) As Integer
  If FromSquare.x = ToSquare.x Then ' North or South
    If FromSquare.y > ToSquare.y Then
      Debug.Assert FromSquare.y = ToSquare.y + 1
      GetDirection = North
    Else
      Debug.Assert FromSquare.y = ToSquare.y - 1
      GetDirection = South
    End If
  Else ' West or East
    Debug.Assert FromSquare.y = ToSquare.y
    If FromSquare.x > ToSquare.x Then
      Debug.Assert FromSquare.x = ToSquare.x + 1
      GetDirection = West
    Else
      Debug.Assert FromSquare.x = ToSquare.x - 1
      GetDirection = East
    End If
  End If
End Function

Function GetAngle(FromAngle As Integer, ToAngle As Integer)
  Dim Angle As Integer
  Angle = (ToAngle + 4 - FromAngle) Mod 4
  Select Case Angle
    Case 0
      Debug.Assert False
    Case 1
      GetAngle = 90
    Case 2
      GetAngle = 180
    Case 3
      GetAngle = -90
  End Select
End Function

' check whether all squares near x,y have been tried
Function TriedAll(x As Integer, y As Integer) As Boolean
  TriedAll = (x = 0 Or Maze(x - 1, y) <> Unknown) And _
     (x = MaxX - 1 Or Maze(x + 1, y) <> Unknown) And _
     (y = 0 Or Maze(x, y - 1) <> Unknown) And _
     (y = MaxY - 1 Or Maze(x, y + 1) <> Unknown)
End Function

' set the neighbor square to wall if last square is Road
Sub SetWall(x As Integer, y As Integer)
    Dim i As Integer
    Dim n As Integer
    
    If Maze(x, y) <> Road Then
        Exit Sub
    End If
    i = 0
    If (x > 0) Then
      n = Maze(x - 1, y)
      If n = Road Or n = Branch Or n = Gold Then
        i = i + 1
      End If
    End If
    If (x < MaxX - 1) Then
      n = Maze(x + 1, y)
      If n = Road Or n = Branch Or n = Gold Then
        i = i + 1
      End If
    End If
    If (y > 0) Then
      n = Maze(x, y - 1)
      If n = Road Or n = Branch Or n = Gold Then
        i = i + 1
      End If
    End If
    If (y < MaxY - 1) Then
      n = Maze(x, y + 1)
      If n = Road Or n = Branch Or n = Gold Then
        i = i + 1
      End If
    End If
    If i < 2 Then
        Exit Sub
    End If
    Debug.Assert i = 2
    If (x > 0) Then
      If Maze(x - 1, y) = Unknown Then
        Maze(x - 1, y) = Wall
      End If
    End If
    If (x < MaxX - 1) Then
      If Maze(x + 1, y) = Unknown Then
        Maze(x + 1, y) = Wall
      End If
    End If
    If (y > 0) Then
      If Maze(x, y - 1) = Unknown Then
        Maze(x, y - 1) = Wall
      End If
    End If
    If (y < MaxY - 1) Then
      If Maze(x, y + 1) = Unknown Then
        Maze(x, y + 1) = Wall
      End If
    End If
End Sub
