VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsControl"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit
Option Base 1
'extra distance of rotation sensor after last run
Dim R0Extra As Integer
Dim R2Extra As Integer
Dim Num180 As Integer
Dim Num90 As Integer
Dim Num_90 As Integer

' Start two motors go forward in speed "Speed"
Sub GoForward(ByVal Speed As Integer)
  frmMaze.PBrickCtrl.SetPower "motor0" + "motor2", CON, Speed
  frmMaze.PBrickCtrl.SetFwd "motor0motor2"
  frmMaze.PBrickCtrl.on "motor0motor2"
End Sub

' Start two motors go backward in speed "Speed"
Sub GoBackward(ByVal Speed As Integer)
  frmMaze.PBrickCtrl.SetPower "motor0" + "motor2", CON, Speed
  frmMaze.PBrickCtrl.SetRwd "motor0" + "motor2"
  frmMaze.PBrickCtrl.on "motor0" + "motor2"
End Sub

' Stop two motors
Sub StopMotor()
  frmMaze.PBrickCtrl.off "motor0motor2"
End Sub

' with motor 0 go distance
' motor 2 go - distance
Sub Rotate(ByVal Angle As Integer)
  Dim distance As Integer
  Dim LeftDistance As Integer
  Dim RightDistance As Integer
  
  IsRotate = True
  
  Select Case Angle
    Case 90
      Num90 = (Num90 + 1) Mod 3
      If Num90 = 1 Then
        distance = 11
      Else
        distance = 11
      End If
    Case -90
      Num_90 = (Num_90 + 1) Mod 3
      If Num_90 = 1 Then
        distance = 11
      Else
        distance = 11
      End If
    Case 180
      Num180 = (Num180 + 1) Mod 3
      If Num180 = 1 Then
        distance = 23
      Else
        distance = 23
      End If
    Case Else
      Debug.Assert False
  End Select
    
  If Angle < 0 Then
    LeftDistance = -distance
    RightDistance = distance
  ElseIf Angle > 0 Then
    LeftDistance = distance
    RightDistance = -distance
  End If
  DoMoveAndStop LeftDistance, RightDistance, 7
  Do Until R0Extra = 0 And R2Extra = 0
    DoMoveAndStop 0, 0, 5
  Loop
End Sub


Public Sub Init()
  Dim b As Boolean
  ActionFinish = True
  ' initialize the program of the robot
  InitMoveAndStop
  Num180 = 0
  Num90 = 0
  Num_90 = 0
End Sub

' go through certain distance and stop
' if distance is negative, go backward
Sub MoveAndStop(ByVal distance As Integer)
  If distance = 0 Then
    Exit Sub
  End If
  DoMoveAndStop distance, distance, 7
  Do While R0Extra <> 0 Or R2Extra <> 0
    DoMoveAndStop 0, 0, 1
  Loop
End Sub

Private Sub DoMoveAndStop(LeftDistance As Integer, RightDistance As Integer, Speed As Integer)
  Dim b As Boolean
  Dim i As Integer
  If Not ActionFinish Then
    MsgBox "Reenter DoMoveAndStop!"
    Exit Sub
  End If
  ActionFinish = False
  With frmMaze.PBrickCtrl
    b = .SetVar(VarActionFinish, CON, 0)
    b = .SetVar(VarColorDiff, CON, VARIANCE)
    b = .SetEvent(VAR, VarActionFinish, 10)
    b = .SetVar(VarR0Distance, CON, RightDistance - R0Extra)
    b = .SetVar(VarR2Distance, CON, LeftDistance - R2Extra)
    b = .SetVar(VarHalfSquare, CON, HalfSquare)
    b = .SetVar(VarSpeed, CON, Speed)
    b = .SelectPrgm(PrgmControl)
    b = .StartTask(TaskMoveAndStop)
    Do Until ActionFinish
      i = .Poll(VAR, VarActionFinish)
      If i = 1 Then
        ActionFinish = True
      End If
    Loop
  End With
  R0Extra = -Sensor.ReadRotationSensor(R0Sensor) - (RightDistance - R0Extra)
  R2Extra = -Sensor.ReadRotationSensor(R2Sensor) - (LeftDistance - R2Extra)
End Sub

Sub InitMoveAndStop()
  Dim b As Boolean
  DownloadFinish = False
  frmMaze.ctrlDownloading = "Downloading"
  frmMaze.ctrlStart.Enabled = False
  frmMaze.ctrlRestart.Enabled = False
  With frmMaze.PBrickCtrl
    .SelectPrgm PrgmControl
    .DeleteTask TaskMoveAndStop
    .BeginOfTask TaskMoveAndStop
      '.SetVar VarActionFinish, CON, 0
      .AbsVar VarR0AbsDist, VAR, VarR0Distance
      .AbsVar VarR2AbsDist, VAR, VarR2Distance
      
    'after reach new color, change the distance left to this value.
      .SetVar VarOldColor, SENVAL, LightSensor
      .SetPower "02", VAR, VarSpeed
      .ClearSensorValue R0Sensor
      .ClearSensorValue R2Sensor
      
      .If VAR, VarR0Distance, GT, CON, 0  '>0
        .SetFwd "0"
        .SetVar VarMotor0Running, CON, 1
      .Else '<=0
        .If VAR, VarR0Distance, NE, CON, 0  '<0
          .SetRwd "0"
          .SetVar VarMotor0Running, CON, 1
        .Else '=0
          .SetVar VarMotor0Running, CON, 0
        .EndIf
      .EndIf
      .If VAR, VarR2Distance, GT, CON, 0  '>0
        .SetFwd "2"
        .SetVar VarMotor2Running, CON, 1
      .Else '<=0
        .If VAR, VarR2Distance, NE, CON, 0  '<0
          .SetRwd "2"
          .SetVar VarMotor2Running, CON, 1
        .Else
          .SetVar VarMotor2Running, CON, 0
        .EndIf
      .EndIf
      .If VAR, VarMotor0Running, EQ, CON, 1
        .If VAR, VarMotor2Running, EQ, CON, 1
          .on "02"
        .Else
          .on "0"
        .EndIf
      .Else
        .If VAR, VarMotor2Running, EQ, CON, 1
          .on "2"
        .EndIf
      .EndIf
      .SetVar VarStopMotor0, CON, 0
      .SetVar VarStopMotor2, CON, 0
      ' VarMotorRunning = VarMotor0Running or VarMotor2Running
      .SetVar VarMotorRunning, VAR, VarMotor0Running
      .OrVar VarMotorRunning, VAR, VarMotor2Running
      .While VAR, VarMotorRunning, NE, CON, 0
        '.SetVar VarCurColor, SENVAL, LightSensor
        '.SubVar VarCurColor, VAR, VarOldColor
        '.AbsVar VarCurColor, VAR, VarCurColor
        '.If VAR, VarCurColor, GT, VAR, VarColorDiff 'change distance to half square
        '  .SubVar VarR2Distance, VAR, VarR0Distance
        '  .SetVar VarR0Distance, VAR, VarHalfSquare
        '  .SumVar VarR2Distance, VAR, VarR0Distance
        '  .AbsVar VarR0AbsDist, VAR, VarR0Distance
        '  .AbsVar VarR2AbsDist, VAR, VarR2Distance
        '.EndIf
        
        ' check rotation sensor 0
        .If VAR, VarMotor0Running, EQ, CON, 1
          .SetVar VarAbsDis, SENVAL, R0Sensor
          .AbsVar VarAbsDis, VAR, VarAbsDis
          .If VAR, VarAbsDis, EQ, VAR, VarR0AbsDist '=
            .SetVar VarMotor0Running, CON, 0
            .SetVar VarStopMotor0, CON, 1
          .Else
            .If VAR, VarAbsDis, GT, VAR, VarR0AbsDist '>
              .SetVar VarMotor0Running, CON, 0
              .SetVar VarStopMotor0, CON, 1
            .EndIf
          .EndIf
        .EndIf
        
        ' check rotation sensor 2
        .If VAR, VarMotor2Running, EQ, CON, 1
          .SetVar VarAbsDis, SENVAL, R2Sensor
          .AbsVar VarAbsDis, VAR, VarAbsDis
          .If VAR, VarAbsDis, EQ, VAR, VarR2AbsDist '=
            .SetVar VarMotor2Running, CON, 0
            .SetVar VarStopMotor2, CON, 1
          .Else
            .If VAR, VarAbsDis, EQ, VAR, VarR2AbsDist '>
              .SetVar VarMotor2Running, CON, 0
              .SetVar VarStopMotor2, CON, 1
            .EndIf
          .EndIf
        .EndIf
        
        .If VAR, VarStopMotor0, EQ, CON, 1
          .SetVar VarStopMotor0, CON, 0
          .If VAR, VarStopMotor2, EQ, CON, 1
            .SetVar VarStopMotor2, CON, 0
            .off "02"
          .Else
            .off "0"
          .EndIf
        .Else
          .If VAR, VarStopMotor2, EQ, CON, 1
            .SetVar VarStopMotor2, CON, 0
            .off "2"
          .EndIf
        .EndIf
        
        .SetVar VarMotorRunning, VAR, VarMotor0Running
        .OrVar VarMotorRunning, VAR, VarMotor2Running
      .EndWhile
      ' wait until the robot is stable
      .Wait CON, 50
      'this task finishes
      .SetVar VarActionFinish, CON, 1
    
    b = .EndOfTask
    If Not b Then
      MsgBox "Download error"
    Else
      'Do Until DownloadFinish
      '  DoEvents
      'Loop
      'DownloadFinish = False
    End If
  End With
End Sub
