Attribute VB_Name = "Global"
Option Explicit
Option Base 1

Public Type Location
  x As Integer
  y As Integer
End Type

' the speed of the motor
Public Speed As Integer

' range of the map
Public Const MaxX As Integer = 21
Public Const MaxY As Integer = 21

' definition of direction
Public Const South As Integer = 0
Public Const West As Integer = 1
Public Const North As Integer = 2
Public Const East As Integer = 3

' definition of colors
Public Const Unknown As Integer = 1
Public Const Wall As Integer = 2
Public Const Gold As Integer = 3
Public Const Road As Integer = 4
Public Const Branch As Integer = 5

Public CurColor As Integer
Public IsRotate As Boolean

Public FoundGold As Boolean
Public DownloadFinish As Boolean

Public Const R0Sensor = SENSOR_1
Public Const LightSensor = SENSOR_2
Public Const R2Sensor = SENSOR_3
'whether the program in RCX finish
Public ActionFinish As Boolean

'task and program name for RCX program
Public Const PrgmControl = 4
Public Const TaskRotate = 1
Public Const TaskMoveAndStop = 2

'variable name for RCX program
Public Const VarActionFinish = 0
Public Const VarStopMotor = 1
Public Const VarMotorRunning = 2
Public Const VarMotor0Running = 3
Public Const VarMotor2Running = 4
Public Const VarHalfSquare = 5
Public Const VarR0Distance = 6 'max value of rotation sensor 0
Public Const VarR2Distance = 7 ' max value of rotation sensor 2
Public Const VarColorDiff = 8
Public Const VarOldColor = 9
Public Const VarR0AbsDist = 10
Public Const VarR2AbsDist = 11
Public Const VarAbsDis = 12
Public Const VarCurColor = 13
Public Const VarStopMotor0 = 14
Public Const VarStopMotor2 = 15
Public Const VarSpeed = 16

' Initialize two classes for RCX robot
Public Search As New clsSearch
Public DebugSearch As Boolean

Public Control As Object
Public Sensor As Object

' for sensor module
Public Const BLUE1 = 835 'road acturally black
Public Const GOLD1 = 726 'goal acturally yellow
Public Const GREY1 = 749 'branch acturally green

Public Const BLUE3 = 793
Public Const GOLD3 = 697
Public Const GREY3 = 752

' variance given for colors
Public Const VARIANCE = 11

' the half length of the square
Public Const SquareLength = 17
Public Const HalfSquare = 8
Public Const RotationCenter = 17
'Public Const DistBeforeRotation = 3
'Public Const DistBack = -6


Public Function GetDirectionName(direction As Integer) As String
  Select Case direction
    Case South
      GetDirectionName = "South"
    Case North
      GetDirectionName = "North"
    Case East
      GetDirectionName = "East"
    Case West
      GetDirectionName = "West"
  End Select
End Function

Public Function GetSquareName(i As Integer) As String
    Select Case i
        Case Unknown
            GetSquareName = "Unknown"
        Case Wall
            GetSquareName = "Wall"
        Case Gold
            GetSquareName = "Gold"
        Case Road
            GetSquareName = "Road"
        Case Branch
            GetSquareName = "Branch"
        Case Else
'            Debug.Assert False
    End Select
End Function

