VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsControl"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit
Option Base 1
'extra distance of rotation sensor after last run
Dim R0Extra As Integer
Dim R2Extra As Integer

' Start two motors go forward in speed "Speed"
Sub GoForward(ByVal Speed As Integer)
  frmMaze.PBrickCtrl.SetPower "motor0" + "motor2", CON, Speed
  frmMaze.PBrickCtrl.SetFwd "motor0motor2"
  frmMaze.PBrickCtrl.on "motor0motor2"
End Sub

' Start two motors go backward in speed "Speed"
Sub GoBackward(ByVal Speed As Integer)
  frmMaze.PBrickCtrl.SetPower "motor0" + "motor2", CON, Speed
  frmMaze.PBrickCtrl.SetRwd "motor0" + "motor2"
  frmMaze.PBrickCtrl.on "motor0" + "motor2"
End Sub

' Stop two motors
Sub StopMotor()
  frmMaze.PBrickCtrl.off "motor0motor2"
End Sub

' Rotate the robot in an angle defined in the parameter
' Let it rotate during the running
Sub Rotate(Angle As Integer)
  Dim begin As Integer
  Dim dis As Integer
  Dim cur1 As Integer
  Dim cur3 As Integer
  Dim Speed As Integer
  
' SSSSSSSSSs  added variable to tell which sensor to read
  Dim Side As Integer
  
  IsRotate = True
  Sensor.ClearRotation
  'begin = sensor.ReadRotationSensor
  Speed = 7
    If Angle = 90 Then
        Side = 1
        frmMaze.PBrickCtrl.SetRwd "motor0"
        frmMaze.PBrickCtrl.SetFwd "motor2"
        frmMaze.PBrickCtrl.SetPower "motor0" + "motor2", CON, Speed
        frmMaze.PBrickCtrl.on "motor0" + "motor2"
        dis = -13
    ElseIf Angle = 180 Then
        frmMaze.PBrickCtrl.SetRwd "motor0"
        frmMaze.PBrickCtrl.SetFwd "motor2"
        frmMaze.PBrickCtrl.SetPower "motor0" + "motor2", CON, Speed
        frmMaze.PBrickCtrl.on "motor0" + "motor2"
        dis = -28
        Side = 1
    ElseIf Angle = -90 Then
        
        Side = 0
        frmMaze.PBrickCtrl.SetRwd "motor2"
        frmMaze.PBrickCtrl.SetFwd "motor0"
        frmMaze.PBrickCtrl.SetPower "motor0" + "motor2", CON, Speed
        frmMaze.PBrickCtrl.on "motor0" + "motor2"
        dis = 13
    End If
    Debug.Print "dis=", dis
    Do
    
  ' sssssssssss added control stucture for two sensors
  
      'If Side = 1 Then
        cur3 = Sensor.ReadRotationSensor(SENSOR_3)
      'ElseIf Side = 0 Then
        cur1 = Sensor.ReadRotationSensor(SENSOR_1)
      'End If
      If Abs(cur1) >= Abs(dis) Then
        frmMaze.PBrickCtrl.off "motor0"
      End If
      If Abs(cur3) >= Abs(dis) Then
        frmMaze.PBrickCtrl.off "motor2"
      End If
    Loop Until Abs(cur1) >= Abs(dis) And Abs(cur3) >= Abs(dis)
    StopMotor
End Sub

Public Sub Init()
  Dim b As Boolean
  ActionFinish = True
  ' initialize the program of the robot
  InitRotate
  InitMoveAndStop
End Sub

' go through certain distance and stop
' if distance is negative, go backward
Sub MoveAndStop(ByVal distance As Integer)
  Dim b As Boolean
  Dim i As Integer
  If Not ActionFinish Then
    MsgBox "Reenter MoveAndStop!"
    Exit Sub
  End If
  ActionFinish = False
  With frmMaze.PBrickCtrl
    b = .SetVar(VarActionFinish, CON, 0)
    b = .SetEvent(VAR, VarActionFinish, 10)
    b = .SetVar(VarR0Distance, CON, distance - R0Extra)
    b = .SetVar(VarR2Distance, CON, distance - R2Extra)
    b = .SetVar(VarHalfSquare, CON, HalfSquare)
    b = .SelectPrgm(PrgmControl)
    b = .StartTask(TaskMoveAndStop)
    Do Until ActionFinish
      i = .Poll(VAR, VarActionFinish)
      If i = 1 Then
        ActionFinish = True
      End If
    Loop
  End With
  R0Extra = -Sensor.ReadRotationSensor(R0Sensor) - (distance - R0Extra)
  R2Extra = -Sensor.ReadRotationSensor(R2Sensor) - (distance - R2Extra)
End Sub

Sub InitMoveAndStop()
  Dim b As Boolean
  DownloadFinish = False
  frmMaze.ctrlDownloading = "Downloading"
  With frmMaze.PBrickCtrl
    .SelectPrgm PrgmControl
    .DeleteTask TaskMoveAndStop
    .BeginOfTask TaskMoveAndStop
      '.SetVar VarActionFinish, CON, 0
      .AbsVar VarR0AbsDist, VAR, VarR0Distance
      .AbsVar VarR2AbsDist, VAR, VarR2Distance
      
    'after reach new color, change the distance left to this value.
      .SetVar VarOldColor, SENVAL, LightSensor
      .SetPower "02", CON, 7
      .ClearSensorValue R0Sensor
      .ClearSensorValue R2Sensor
      
      .If VAR, VarR0Distance, GT, CON, 0  '>0
        .SetFwd "0"
        .SetVar VarMotor0Running, CON, 1
      .Else '<=0
        .If VAR, VarR0Distance, NE, CON, 0  '<0
          .SetRwd "0"
          .SetVar VarMotor0Running, CON, 1
        .Else '=0
          .SetVar VarMotor0Running, CON, 0
        .EndIf
      .EndIf
      .If VAR, VarR2Distance, GT, CON, 0  '>0
        .SetFwd "2"
        .SetVar VarMotor2Running, CON, 1
      .Else '<=0
        .If VAR, VarR2Distance, NE, CON, 0  '<0
          .SetRwd "2"
          .SetVar VarMotor2Running, CON, 1
        .Else
          .SetVar VarMotor2Running, CON, 0
        .EndIf
      .EndIf
      .If VAR, VarMotor0Running, EQ, CON, 1
        .If VAR, VarMotor2Running, EQ, CON, 1
          .on "02"
        .Else
          .on "0"
        .EndIf
      .Else
        .If VAR, VarMotor2Running, EQ, CON, 1
          .on "2"
        .EndIf
      .EndIf
      ' VarMotorRunning = VarMotor0Running or VarMotor2Running
      .SetVar VarMotorRunning, VAR, VarMotor0Running
      .OrVar VarMotorRunning, VAR, VarMotor2Running
      .While VAR, VarMotorRunning, EQ, CON, 1
        ' check rotation sensor 2
        .SetVar VarAbsDis, SENVAL, R2Sensor
        .AbsVar VarAbsDis, VAR, VarAbsDis
        .If VAR, VarAbsDis, EQ, VAR, VarR2AbsDist '=
          .SetVar VarMotor0Running, CON, 0
          .SetVar VarMotor2Running, CON, 0
          '.off "2"
          .off "02"
        .Else
          .If VAR, VarAbsDis, EQ, VAR, VarR2AbsDist '>
            .SetVar VarMotor0Running, CON, 0
            .SetVar VarMotor2Running, CON, 0
            '.off "2"
            .off "02"
          .EndIf
        .EndIf
        
        ' check rotation sensor 0
        .SetVar VarAbsDis, SENVAL, R0Sensor
        .AbsVar VarAbsDis, VAR, VarAbsDis
        .If VAR, VarAbsDis, EQ, VAR, VarR0AbsDist '=
          .SetVar VarMotor0Running, CON, 0
          .SetVar VarMotor2Running, CON, 0
          '.off "0"
          .off "02"
        .Else
          .If VAR, VarAbsDis, GT, VAR, VarR0AbsDist '>
            .SetVar VarMotor0Running, CON, 0
            .SetVar VarMotor2Running, CON, 0
            '.off "0"
            .off "02"
          .EndIf
        .EndIf
        .SetVar VarMotorRunning, VAR, VarMotor0Running
        .OrVar VarMotorRunning, VAR, VarMotor2Running
      .EndWhile
      'this task finishes
      .SetVar VarActionFinish, CON, 1
    
    b = .EndOfTask
    If Not b Then
      MsgBox "Download error"
    Else
      'Do Until DownloadFinish
      '  DoEvents
      'Loop
      'DownloadFinish = False
    End If
  End With
End Sub

Sub InitRotate()

End Sub

Sub OldMoveAndStop(ByVal distance As Integer)
  Dim begin As Integer
  Dim dis As Integer
  Dim cur As Integer
  Dim Speed As Integer
  Dim prevColor1 As Integer
  Dim prevColor2 As Integer
  Dim curColor1 As Integer
  Dim curColor2 As Integer
  Dim command As String
  Dim stopped As Integer
  Dim motor0Running As Boolean
  Dim motor2Running As Boolean
  Dim i, j As Integer
  
  Sensor.ClearRotation
  i = Sensor.ReadRotationSensor(SENSOR_1)
  j = Sensor.ReadRotationSensor(SENSOR_3)
  begin = (i + j) / 2
  Speed = distance
  
' SSSSSSSSSSSSSs removed one sensor and made some changes below to
'    reflect

  curColor1 = Sensor.GetColorFromOne(SENSOR_2)
  curColor2 = Sensor.GetColorFromOne(SENSOR_2)
  
  prevColor1 = curColor1
  prevColor2 = curColor2
  
  If Speed > 4 Then
    Speed = 4
  End If
  dis = Abs(distance)
  If distance < 0 Then
    GoBackward Speed
  Else
    GoForward Speed
  End If
  command = ""
  stopped = 0
  motor0Running = True
  motor2Running = True
  Do
    i = Sensor.ReadRotationSensor(SENSOR_1)
    j = Sensor.ReadRotationSensor(SENSOR_3)
    cur = (i + j) / 2
  Loop Until Abs(cur) >= Abs(dis)
  If stopped < 2 Then
    StopMotor
  End If
End Sub
Sub OldCode()
  Dim begin As Integer
  Dim dis As Integer
  Dim cur As Integer
  Dim Speed As Integer
  Dim prevColor1 As Integer
  Dim prevColor2 As Integer
  Dim curColor1 As Integer
  Dim curColor2 As Integer
  Dim command As String
  Dim stopped As Integer
  Dim motor0Running As Boolean
  Dim motor2Running As Boolean
  Dim i, j As Integer
  Do
    curColor1 = Sensor.GetColorFromOne(SENSOR_2)
    'If curColor1 <> prevColor1 Then
    '  command = command + "motor0motor2"
    '  motor0Running = False
    '  motor2Running = False
    '  stopped = stopped + 2
    'End If
    If motor0Running Then
      i = Sensor.ReadRotationSensor(SENSOR_1)
      If Abs(i) >= Abs(dis) Then
        command = command + "motor0"
        motor0Running = False
        stopped = stopped + 1
      End If
    End If
    If motor2Running Then
      i = Sensor.ReadRotationSensor(SENSOR_2)
      If Abs(i) >= Abs(dis) Then
        command = command + "motor2"
        motor2Running = False
        stopped = stopped + 1
      End If
    End If
    If command <> "" Then
      frmMaze.PBrickCtrl.off command
      command = ""
    End If
    If stopped >= 2 Then ' all motors stops
      Exit Do
    End If
  Loop
End Sub

